#ifndef STARTUP_IMPACT_APPLICATION_PROPERTIES_H
#define STARTUP_IMPACT_APPLICATION_PROPERTIES_H

#include <FlyAdminStartUpImpact/Global>

#include <FlyAdminStartUpImpact/ProcessData>

#include <QString>

class StartUpImpactParser;
class StartUpImpactApplicationMetrics;

class STARTUP_IMPACT_PARSER_EXPORT StartUpImpactApplicationProperties
{
public:
    explicit StartUpImpactApplicationProperties();
    virtual ~StartUpImpactApplicationProperties();

    QString appName() const;
    StartUpImpactProcessData data() const;

    StartUpImpactApplicationProperties(const StartUpImpactApplicationProperties &other);
    StartUpImpactApplicationProperties &operator=(const StartUpImpactApplicationProperties &other);

    StartUpImpactApplicationProperties(StartUpImpactApplicationProperties &&that) noexcept;
    StartUpImpactApplicationProperties &operator=(StartUpImpactApplicationProperties &&that) noexcept;

    inline void swap(StartUpImpactApplicationProperties &lhs,
                     StartUpImpactApplicationProperties &rhs) noexcept;

private:
    explicit StartUpImpactApplicationProperties(const QString &appName,
                                                const StartUpImpactProcessData &data);

    QString m_appName;
    StartUpImpactProcessData m_data;

    void setAppName(const QString &appName);
    void setData(const StartUpImpactProcessData &data);

    friend class StartUpImpactParser;
    friend class StartUpImpactApplicationMetrics;
};

void StartUpImpactApplicationProperties::swap(StartUpImpactApplicationProperties &lhs,
                                              StartUpImpactApplicationProperties &rhs) noexcept
{
    std::swap(lhs.m_appName, rhs.m_appName);
    std::swap(lhs.m_data, rhs.m_data);
}

#endif // STARTUP_IMPACT_APPLICATION_PROPERTIES_H
