#ifndef STARTUP_IMPACT_CATEGORY_CALCULATOR_SETTINGS_H
#define STARTUP_IMPACT_CATEGORY_CALCULATOR_SETTINGS_H

#include <QSettings>

#include <FlyAdminStartUpImpact/CategoryCalculator>

class STARTUP_IMPACT_PARSER_EXPORT StartUpImpactCategoryCalculatorSettings : public QSettings
{
    Q_OBJECT

public:
    explicit StartUpImpactCategoryCalculatorSettings(QObject *parent = nullptr);

    void setData(const StartUpImpactCategoryCalculatorData &calcData);
    StartUpImpactCategoryCalculatorData data() const;
    void saveData();
    void loadData();

    qlonglong startMediumIOReadWriteBytes() const;
    uint startMediumCpuTimeMilliseconds() const;

    qlonglong startHighIOReadWriteBytes() const;
    uint startHighCpuTimeMilliseconds() const;

    static QString mainGroupName();
    static QString startMediumIOReadWriteBytesParamName();
    static QString startMediumCpuTimeMillisecondsParamName();
    static QString startHighIOReadWriteBytesParamName();
    static QString startHighCpuTimeMillisecondsParamName();

protected:
    void beginMainGroup();

private:
    StartUpImpactCategoryCalculatorData m_calcData;
};

#endif // STARTUP_IMPACT_CATEGORY_CALCULATOR_SETTINGS_H
