#ifndef STARTUP_IMPACT_FLY_SETTINGS_H
#define STARTUP_IMPACT_FLY_SETTINGS_H

#include <FlyAdminStartUpImpact/Global>

#include <QStringList>

class StartUpImpactFlySettingsPrivate;

class StartUpImpactFlySettings
{
public:
    enum Scope {
        CurrentUserScope = 0,
        DefaultUserScope // For new users
    };

    explicit StartUpImpactFlySettings(Scope scope = CurrentUserScope);
    virtual ~StartUpImpactFlySettings();

    void setStartupAnalyzeEnable(bool isEnable);
    bool isStartupAnalyzeEnable() const;
    bool saveStartupAnalyzeEnable();
    void loadStartupAnalyzeEnable();

    static QString themeConfigFilePath(Scope scope);
    static QString variablesGroupName();
    static QString autostartMonitorParamName();

private:
    StartUpImpactFlySettingsPrivate *d;

    void init(Scope scope);

    bool setAutoStartModitorEnable(const char *fileName, bool isEnable);
    bool isAutoStartModitorEnable(const char *fileName);

#if QT_VERSION < QT_VERSION_CHECK(5, 13, 0)
    Q_DISABLE_COPY(StartUpImpactFlySettings)
#else
    Q_DISABLE_COPY_MOVE(StartUpImpactFlySettings)
#endif
};

#endif // STARTUP_IMPACT_FLY_SETTINGS_H
