#ifndef STARTUP_IMPACT_PROCESS_DATA_H
#define STARTUP_IMPACT_PROCESS_DATA_H

#include <FlyAdminStartUpImpact/Global>

class STARTUP_IMPACT_PARSER_EXPORT StartUpImpactProcessData
{
public:
    explicit StartUpImpactProcessData(qlonglong ioReadWriteBytes = 0,
                                      uint cpuTimeMilliseconds = 0,
                                      StartUpImpact::Category category = StartUpImpact::Category::UnknowImpact);
    virtual ~StartUpImpactProcessData();

    bool isNull() const;

    qlonglong ioReadWriteBytes() const;
    void setIOReadWriteBytes(qlonglong ioReadWriteBytes);

    uint cpuTimeMilliseconds() const;
    void setCPUTimeMilliseconds(uint cpuTimeMilliseconds);

    StartUpImpact::Category category() const;
    void setCategory(StartUpImpact::Category category);

    StartUpImpactProcessData(const StartUpImpactProcessData &other);
    StartUpImpactProcessData &operator=(const StartUpImpactProcessData &other);

    StartUpImpactProcessData(StartUpImpactProcessData &&that) noexcept;
    StartUpImpactProcessData &operator=(StartUpImpactProcessData &&that) noexcept;

    inline void swap(StartUpImpactProcessData &lhs,
                     StartUpImpactProcessData &rhs) noexcept;

private:
    qlonglong m_ioReadWriteBytes;
    uint m_cpuTimeMilliseconds;
    StartUpImpact::Category m_category;
};

inline void StartUpImpactProcessData::swap(StartUpImpactProcessData &lhs,
                                           StartUpImpactProcessData &rhs) noexcept
{
    std::swap(lhs.m_ioReadWriteBytes, rhs.m_ioReadWriteBytes);
    std::swap(lhs.m_cpuTimeMilliseconds, rhs.m_cpuTimeMilliseconds);
    std::swap(lhs.m_category, rhs.m_category);
}

#endif // STARTUP_IMPACT_PROCESS_DATA_H
